/*  
 * Copyright (c) 2010 Ant Kutschera, maxant
 * 
 * This file is part of the maxant PersistentStateMachine.
 * 
 * maxant PersistentStateMachine is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant PersistentStateMachine is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with maxant PersistentStateMachine.  If not, see <http://www.gnu.org/licenses/>.
 */
package uk.co.maxant.demo.scxml.data;

import javax.persistence.EntityManager;

/**
 * A class which handles data access.  
 */
public final class SomethingPersistentWithStateDao {

	private EntityManager entityManager;

	public SomethingPersistentWithStateDao(EntityManager entityManager){
		this.entityManager = entityManager;
	}

	/**
     * reads the given item out of the database.
     * @param id pk of object to read
     * @return an instance of the persisted object
     */
    public SomethingPersistentWithState readById(int id){
        SomethingPersistentWithState o = entityManager.find(SomethingPersistentWithState.class, id);

        return o;
    }

    /**
     * persists this item to the database
     */
    public void persist(SomethingPersistentWithState o){
        if(o.getIdPk() == 0){
        	//save new instance
        	entityManager.persist(o);
        }else{
        	//update existing instance
        	entityManager.merge(o);
        }
    }
    

}
